<script setup lang="ts">
    import { computed, ref } from 'vue'
    import { Message } from '../../entities/messages/Message'
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import { isDefined } from '@/shared/helpers/types'
    import SDateRangeField from '@/shared/formField/components/SDateRangeField.vue'

    interface Props {
        modelValue: Partial<Message>
        loading: boolean
    }

    const props = defineProps<Props>()

    const emit = defineEmits<{
        'update:modelValue': [value: Partial<Message>]
    }>()

    const message = computed({
        get() {
            return props.modelValue
        },
        set(message) {
            emit('update:modelValue', message)
        },
    })

    const formIsValid = ref<boolean>(false)
    const titleMaxSize = 256
    const bodyMaxSize = 401

    const rules = {
        hasTitle: (input: string | undefined) =>
            !!input || 'Vous devez renseigner un sujet',
        titleMaxSize: (input: string) =>
            input.length < titleMaxSize ||
            'Le sujet doit faire moins de ' + titleMaxSize + ' caractères',
        bodyMaxSize: (input: string) =>
            isDefined(input)
                ? input.length < bodyMaxSize ||
                  'Le corps du message doit faire moins de ' +
                      bodyMaxSize +
                      ' caractères'
                : true,
        hasColor: (input: string | undefined) =>
            !!input || 'Vous devez renseigner une couleur',
    }
</script>
<template>
    <v-form v-model="formIsValid">
        <v-row>
            <v-col cols="12">
                <v-text-field
                    v-model="message.title"
                    label="Sujet du message*"
                    class="mb-3"
                    :rules="[rules.hasTitle, rules.titleMaxSize]"
                    data-cy="message-title"
                    hide-details="auto"
                ></v-text-field
            ></v-col>
            <v-col cols="12">
                <v-textarea
                    v-model="message.body"
                    label="Corps du message"
                    variant="outlined"
                    class="mb-3"
                    :rules="[rules.bodyMaxSize]"
                    data-cy="message-body"
                    hint="Utiliser les balises <b></b> pour mettre en gras : <b>Mot en gars</b>"
                    :counter="bodyMaxSize - 1"
                    hide-details="auto"
                    auto-grow
                ></v-textarea>
            </v-col>
            <v-col cols="12">
                <v-select
                    v-model="message.color"
                    label="Couleur de l'arrière-plan"
                    variant="outlined"
                    class="mb-3"
                    :rules="[rules.hasColor]"
                    :items="[
                        { title: 'Information', value: 'info' },
                        { title: 'Information positive', value: 'success' },
                        { title: 'Problème', value: 'warning' },
                        { title: 'Problème grave', value: 'error' },
                    ]"
                    item-text="title"
                    item-value="value"
                    data-cy="message-color"
                    hide-details="auto"
                ></v-select>
            </v-col>
            <s-date-range-field
                v-model:date-de-debut="message.startDate"
                v-model:date-de-fin="message.endDate"
            />
        </v-row>

        <p class="text-right mt-8">
            <s-action-button
                icon="mdi-check"
                label="Enregistrer"
                data-cy="register-message-button"
                :disabled="!formIsValid"
                :loading="loading"
                type="submit"
            >
            </s-action-button>
        </p>
    </v-form>
</template>
